Notification subclass: #JSBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!


OMeta subclass: #JSCompiler
	instanceVariableNames: 'contextLevel numTemps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 9/11/2007 16:10'!
compile ::=

	#ctxt													=> [self currentContext]
|	{#quote <anything>:x}									=> [x printString]
|	{#squote <anything>:x}									=> [x asString]
|	{#if <compile>:c <compile>:t}								=> [{'(('. c, ' jsSend: #''__toBoolean__'' withArguments: #()) ifTrue: ['. t. '])'}]
|	{#if <compile>:c <compile>:t <compile>:f}					=> [{'(('. c, ' jsSend: #''__toBoolean__'' withArguments: #()) ifTrue: ['. t. ']'. ' ifFalse: ['. f. '])'}]
|	{#call <compile>:f <compileListElement>*:as}				=> [{'('. f. ' jsCallWithArguments: {'. as. '})'}]
|	{#send <anything>:m <compile>:r <compileListElement>*:as}	=> [{'('. r. ' jsSend: '. m printString. ' withArguments: {'. as. '})'}]
|	{#begin <compileListElement>*:xs}							=> [{'(true ifTrue: ['. xs. '])'}]
|	{#get <compile>:c <compile>:n}								=> [{'('. c. ' jsAt: '. n. ' asJSKey)'}]
|	{#set {#get <compile>:c <compile>:n} <compile>:v}			=> [{'('. c. ' jsAt: '. n. ' asJSKey put: '. v. ')'}]
|	{#set <compile>:c <compile>:n <compile>:v}					=> [{'('. c. ' jsAt: '. n. ' asJSKey put: '. v. ')'}]
|	{#func <anything>:args
		!![self pushContext]:newContext
		!![self squeakContext]:squeakContext
		<compile>:body
		!![self popContext]}									=> [{	'(JSObject functionWithEnv: '. self currentContext.
																' args: '. args asArray printString.
																' body: [:'. newContext. ' | | '. squeakContext. ' | '. squeakContext. ' := thisContext. '. body. '. '. squeakContext. ' return: ('. newContext. ' jsAt: #undefined)])'}]
|	{#return <compile>:x}									=> [{self squeakContext. ' return: '. x}]
|	{#return}												=> [{self squeakContext. ' return: nil'}]
|	{#break}												=> ['JSBreak signal']
|	{#continue}												=> ['JSContinue signal']
|	{#decl <anything>:n}										=> [{'('. self currentContext. ' at: '. n printString. ' put: ('. self currentContext. ' jsAt: #undefined))'}]
|	{#while <compile>:c <compile>:s}							=> [{'([['. c. '] whileTrue: [['. s. '] on: JSContinue do: []]] on: JSBreak do: [])'}]
|	{#doWhile <compile>:s <compile>:c}							=> [{'([[['. s. '] on: JSContinue do: []. '. c. '] whileTrue] on: JSBreak do: [])'}]
|	{#forIn <compile>:setter <compile>:e <compile>:s}			=> [{'('. e. ' jsIterateWithCtxt: '. self currentContext. ' setter: '. setter. ' body: ['. s. '])'}]
|	{#for <compile>:i <compile>:c <compile>:u <compile>:s}		=> [{'(['. i. '. ['. c. '] whileTrue: [['. s. '] on: JSContinue do: []. '. u. ']] on: JSBreak do: [])'}]
|	{#switch
		!![self makeTemp]:expr !![self makeTemp]:shouldEval
		<compile>:e <compileCase expr shouldEval>*:cs}			=> [{'([| '. expr. ' '. shouldEval. ' | '. expr. ' := '. e. '. '. shouldEval. ' := false. ['. cs. '] on: JSBreak do: []] value)'}]
|	{#throw <compile>:x}										=> [{'((JSThrow withValue: '. x. ') signal)'}]
|	{#try <compile>:x <anything>:e <compile>:c <compile>:f}
		!![self makeTemp]:throw								=> [{'([['. x. '] on: JSThrow do: [:'. throw. ' | '. self currentContext. ' jsAt: #'. e. ' put: '. throw. ' value. '. c. ']] ensure: ['. f. '])'}]
|	{#new <compile>:c <compileListElement>*:as}				=> [{'('. c. ' jsNewWithArguments: {'. as. '})'}]
|	{#source <compile>:f <anything>:s} !![self makeTemp]:t		=> [{'(true ifTrue: [ | '. t. ' | '. t. ' := '. f. '. '. t. ' at: #''__code__'' put: '. s printString. '. '. t. '])'}]
|	{#post <anything>:m <anything>:x}
		<empty x> <compile>:cx
		!![self makeTemp]:t
			<empty {#set. x. {#send. m.
								{#squote. t}.
								{#quote. 1}}}> <compile>:u		=> [{'(true ifTrue: [ |'. t. ' | '. t. ' := '. cx. '. '. u. '. '. t. '])'}]! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 21:59'!
compileCase :expr :shouldEval ::=

	{#default <compile>:x}			=> [{x. '. '}]
|	{#case <compile>:e <compile>:x}	=> [{'('. expr. ' jsSend: #=== withArguments: {'. e. '}) ifTrue: ['. shouldEval. ' := true]. '.
										shouldEval. ' ifTrue: ['. x. ']. '}]! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 17:02'!
compileListElement ::=

	<compile>:x	=> [{x. '. '}]! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 18:28'!
currentContext

	^ contextLevel == 0
		ifTrue: ['global']
		ifFalse: ['ctxt', contextLevel printString]! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 13:08'!
initialize

	super initialize.
	contextLevel := 0.
	numTemps := 0.! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 13:12'!
makeTemp

	numTemps := numTemps + 1.
	^ 'jsTemp', numTemps printString! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 8/27/2007 15:09'!
popContext

	contextLevel := contextLevel - 1.
	^ self currentContext! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 8/27/2007 15:09'!
pushContext

	contextLevel := contextLevel + 1.
	^ self currentContext! !

!JSCompiler methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 21:47'!
squeakContext

	^ 'squeakCtxt', contextLevel printString! !


Notification subclass: #JSContinue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!


OMeta subclass: #JSDeclVisitor
	instanceVariableNames: 'declsStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSDeclVisitor methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:04'!
addDecl: n

	declsStack notEmpty ifTrue: [
		declsStack last add: {#decl. n}
	]! !

!JSDeclVisitor methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 19:05'!
decls ::=

	{#decl <anything>:n}					!![self addDecl: n]			=> [{#get. #ctxt. {#quote. n}}]
|	{#decl <anything>:n <decls>:v}		!![self addDecl: n]			=> [{#set. #ctxt. {#quote. n}. v}]
|	{#func <anything>:args				!![self enterFunction]
			<decls>:body					!![self leaveFunction]:setup}	=> [{#func. args. {#begin. setup. body}}]
|	~(<anything>:x ?[x isString or: [x isSymbol]]) {<decls>*:xs}			=> [xs]
|	<anything>! !

!JSDeclVisitor methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 12:54'!
enterFunction

	declsStack add: IdentitySet new! !

!JSDeclVisitor methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:04'!
initialize

	super initialize.
	declsStack := OrderedCollection new.! !

!JSDeclVisitor methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:06'!
leaveFunction

	^ (declsStack removeLast) asOrderedCollection addFirst: #begin; yourself! !


Object subclass: #JSEvaluator
	instanceVariableNames: 'global'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSEvaluator methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 22:17'!
evaluate: compiledCode withGlobal: aJSObject

	global := aJSObject.
	^ Compiler new evaluate: compiledCode in: nil to: self! !


!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 14:49'!
bridgeSqueakMethod: m as: n

	self jsAt: n put:
		(JSObject functionWithEnv: Global args: #() body: [:ctxt |
				(ctxt at: #this) perform: m withArguments: (ctxt jsAt: #arguments)
			]
		)
! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 13:11'!
callWithArguments: args

	^ (self jsAt: #'__body__') copy fixTemps value: (self createActivationRecord: args)! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 14:18'!
createActivationRecord: args

	| activationRecord argNames argStream |
	activationRecord := (self jsAt: #'__env__') makeChild.
	activationRecord at: #arguments put: args.
	argNames := self jsAt: #'__args__'.
	argStream := args readStream.
	argNames do: [:name |
		activationRecord
			at: name
			put: (argStream atEnd ifTrue: [Undefined] ifFalse: [argStream next])
	].
	^ activationRecord! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 14:17'!
hash

	^ self identityHash! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 9/12/2007 18:40'!
jsArrayValues

	| ans |
	ans := OrderedCollection new.
	0 to: (self jsAt: #length) - 1 do: [:idx | ans add: (self jsAt: idx)].
	^ ans asArray! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 9/10/2007 21:12'!
jsAt: key

	^ self at: key ifAbsent: [
		(self at: #'__proto__') jsAt: key
	]! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:33'!
jsAt: key put: val

	^ self at: key put: val! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 9/13/2007 14:06'!
jsKeys

	| obj keys |
	obj := self.
	keys := IdentitySet new.
	[
		self keys do: [:k | (k isSymbol and: [(k beginsWith: '__') and: [k endsWith: '__']]) ifFalse: [keys add: k]].
		obj == ObjectProto ifTrue: [false] ifFalse: [obj := obj jsAt: #'__proto__'. true]
	] whileTrue.
	^ keys asArray! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 13:12'!
jsNewWithArguments: args

	| activationRecord |
	activationRecord := (self createActivationRecord: args)
		at: #this put: (self jsAt: #prototype) makeChild;
		yourself.
	(self jsAt: #'__body__') copy fixTemps
		value: activationRecord.
	^ activationRecord jsAt: #this! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 22:28'!
makeChild

	^ self class new
		at: #'__proto__' put: self;
		yourself! !

!JSObject methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 18:14'!
makeSandbox

	^ self copy! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

JSObject class
	instanceVariableNames: ''!

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 06:46'!
arrayProto

	^ ArrayProto! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 10:32'!
booleanProto

	^ BooleanProto! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 9/12/2007 12:03'!
eval: code

	^ self eval: code withGlobal: self global makeSandbox! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 9/12/2007 12:04'!
eval: code withGlobal: global

	global
		jsAt: #'__global__' put: global;
		jsAt: #eval put: (self functionWithEnv: global args: #(x) body: [:ctxt | JSObject eval: ((ctxt at: #x) jsSend: #toString withArguments: #()) withGlobal: (global jsAt: #'__global__')]).
	^ (self parser on: code readStream) apply: #evalSrcElems withArguments: {global}! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 9/12/2007 12:08'!
functionWithEnv: env args: args body: body

	^ FunctionProto makeChild
		at: #'__code__'	put: '[built-in function]';
		at: #'__env__'	put: env;
		at: #'__args__'	put: args;
		at: #'__body__'	put: body;
		at: #prototype	put: ObjectProto makeChild;
		yourself! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/23/2007 11:30'!
global

	^ Global! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 9/17/2007 10:09'!
initialize
"
	JSObject initialize
"

	| identityConstructor identityConstructorFactory arrayConstructor |
	JSParser initialize.
	ObjectProto := JSObjectProto new.
	Global := JSGlobalProto new.
	FunctionProto := ObjectProto makeChild.
	FunctionProto
		jsAt: #apply put: (self functionWithEnv: Global args: #(thisArg argArray) body: [:ctxt |
			| f args |
			f := ctxt jsAt: #this.
			args := ctxt jsAt: #argArray.
			args == Undefined ifTrue: [args := ArrayProto makeChild].
			(f jsAt: #'__body__') copy fixTemps value: ((f createActivationRecord: args jsArrayValues)
															at: #this put: (ctxt jsAt: #thisArg);
															yourself)
		]);
		jsAt: #call put: (self functionWithEnv: Global args: #(thisArg) body: [:ctxt |
			| f args |
			f := ctxt jsAt: #this.
			args := ctxt jsAt: #arguments.
			(f jsAt: #'__body__') copy fixTemps value: ((f createActivationRecord: (args copyFrom: 2 to: args size))
															at: #this put: (ctxt jsAt: #thisArg);
															yourself)
		]).
	ObjectProto
		at: #'__proto__' put: nil;
		bridgeSqueakMethod: #~= as: #!!=;
		bridgeSqueakMethod: #= as: #==;
		bridgeSqueakMethod: #== as: #===;
		bridgeSqueakMethod: #~== as: #!!==;
		jsAt: #!! put: (self functionWithEnv: Global args: #() body: [:ctxt | ((ctxt jsAt: #this) jsSend: #'__toBoolean__' withArguments: #()) not]);
		jsAt: #'__localProperties__' put: (self functionWithEnv: Global args: #() body: [:ctxt | (ctxt jsAt: #this) keys asArray]).
	Undefined := ObjectProto makeChild.
	Global
		at: #undefined put: Undefined;
		at: #toString put: (self functionWithEnv: Global args: #() body: [:ctxt | '[Global]']);
		at: #printString put: (self functionWithEnv: Global args: #() body: [:ctxt | (ObjectProto jsAt: #printString) jsSend: #call withArguments: {ctxt jsAt: #this}]).
	NumberProto := JSBuiltInProto new
		at: #'__proto__' put: 0;
		jsAt: #toString put: (self functionWithEnv: Global args: #() body: [:ctxt | (ctxt jsAt: #this) asString]);
		jsAt: #toFixed put: (self functionWithEnv: Global args: #(n) body: [:ctxt |
			| n |
			n := (ctxt jsAt: #n).
			n == Undefined ifTrue: [n := 0].
			(ctxt jsAt: #this) printShowingDecimalPlaces: n
		]);
		bridgeSqueakMethod: #+ as: #+;
		bridgeSqueakMethod: #- as: #-;
		bridgeSqueakMethod: #* as: #*;
		bridgeSqueakMethod: #/ as: #/;
		bridgeSqueakMethod: #\\ as: #%;
		bridgeSqueakMethod: #> as: #>;
		bridgeSqueakMethod: #>= as: #>=;
		bridgeSqueakMethod: #< as: #<;
		bridgeSqueakMethod: #<= as: #<=;
		yourself.
	StringProto := JSBuiltInProto new
		at: #'__proto__' put: '';
		jsAt: #toString put: (self functionWithEnv: Global args: #() body: [:ctxt | ctxt jsAt: #this]);
		jsAt: #=== put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #this) jsSend: #== withArguments: {ctxt jsAt: #x}]);
		jsAt: #charCodeAt put: (self functionWithEnv: Global args: #() body: [:ctxt |
			((ctxt jsAt: #this) jsSend: #charAt withArguments: #(0))
				first asciiValue
		]);
		bridgeSqueakMethod: #, as: #+;
		yourself.
	NullProto := ObjectProto makeChild.
	BooleanProto := ObjectProto makeChild
		jsAt: #toString put: (self functionWithEnv: Global args: #() body: [:ctxt | (ctxt jsAt: #this) printString]);
		yourself.
	identityConstructor := self functionWithEnv: Global args: #(x) body: [:ctxt | ctxt jsAt: #this put: (ctxt jsAt: #x)].
	identityConstructorFactory := [:c | identityConstructor copy at: #prototype put: c; yourself].
	arrayConstructor := self functionWithEnv: Global args: #() body: [:ctxt |
		| this arguments |
		this := ctxt jsAt: #this.
		arguments := ctxt jsAt: #arguments.
		arguments size == 0 ifTrue: [this jsAt: #length put: 0].
		arguments size == 1 ifTrue: [
			arguments first isInteger
				ifTrue: [this jsAt: #length put: arguments first]
				ifFalse: [this jsAt: 0 put: arguments first]
		].
		(arguments size > 1) ifTrue: [
			arguments withIndexDo: [:a :i | this jsAt: i - 1 put: a]
		].
	].
	ArrayProto := JSArray new
		at: #length put: 0;
		jsAt: #'__proto__' put: ObjectProto;
		yourself.
	arrayConstructor jsAt: #prototype put: ArrayProto.
	Global
		jsAt: #null put: nil;
		jsAt: #true put: true;
		jsAt: #false put: false;
		jsAt: #Infinity put: Float infinity;
		jsAt: #usleep put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (Delay forMilliseconds: (ctxt jsAt: #x)) wait]);
		jsAt: #alert put: (self functionWithEnv: Global args: #(x) body: [:ctxt | nil inform: ((ctxt at: #x) jsSend: #toString withArguments: #())]);
		jsAt: #print put: (self functionWithEnv: Global args: #(x) body: [:ctxt | Transcript show: ((ctxt at: #x) jsSend: #toString withArguments: #())]);
		jsAt: #eval put: (self functionWithEnv: Global args: #(x) body: [:ctxt | JSObject eval: ((ctxt at: #x) jsSend: #toString withArguments: #())]);
		jsAt: #Object put: ((self functionWithEnv: Global args: #() body: [:ctxt | nil]) at: #prototype put: ObjectProto; yourself);
		jsAt: #Function put: ((self functionWithEnv: Global args: #() body: [:ctxt | nil]) at: #prototype put: FunctionProto; yourself);
		jsAt: #Boolean put: ((self functionWithEnv: Global args: #() body: [:ctxt | nil]) at: #prototype put: BooleanProto; yourself);
		jsAt: #Number put: (identityConstructorFactory value: 0);
		jsAt: #String put: (identityConstructorFactory value: '');
		jsAt: #Array put: arrayConstructor;
		jsAt: #Math put: (
			ObjectProto makeChild
				jsAt: #pi put: Float pi;
				jsAt: #abs put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) abs]);
				jsAt: #sin put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) sin]);
				jsAt: #cos put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) cos]);
				jsAt: #tan put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) tan]);
				jsAt: #atan2 put: (self functionWithEnv: Global args: #(x y) body: [:ctxt | (ctxt jsAt: #x) arcTan: (ctxt jsAt: #y)]);
				jsAt: #floor put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) floor]);
				jsAt: #round put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) rounded]);
				jsAt: #sqrt put: (self functionWithEnv: Global args: #(x) body: [:ctxt | (ctxt jsAt: #x) sqrt]);
				jsAt: #'__random__' put: Random new;
				jsAt: #random put: (self functionWithEnv: Global args: #() body: [:ctxt | ((ctxt jsAt: #Math) jsAt: #'__random__') next]);
				yourself
		);
		yourself.
	self eval: '
		Object.prototype.__toBoolean__ = function() { return true; }
		Boolean.prototype.__toBoolean__ = function() { return this; }
		Number.prototype.__toBoolean__ = function() { return this !!= 0; }
		null.__toBoolean__ = function() { return false; }
		undefined.__toBoolean__ = function() { return false; }

		Object.prototype["&&"] = function(thatThunk) { return this.__toBoolean__() ? thatThunk().__toBoolean__() : false }
		Object.prototype["||"] = function(thatThunk) { return this.__toBoolean__() ? true : thatThunk().__toBoolean__() }

		undefined.toString = function() { return "undefined" }
		null.toString = function() { return "null" }
		Object.prototype.toString = function() { return "[object Object]" }
		Function.prototype.toString = function() { return this.__code__ }
		Array.prototype.genericPrint = function(m) {
			var first = true, r = "["
			for (var idx in this) {
				if (first) first = false
				else r = r + ", "
				r = r + this[idx].perform(m)
			}
			return r + "]"
		}
		Array.prototype.toString = function() { return this.genericPrint("toString") }

		justToString = function() { return this.toString() }
		undefined.printString = justToString
		null.printString = justToString
		Object.prototype.printString = function() {
			var first = true, r = "{"
			for (var idx in this) {
				if (first) first = false
				else r = r + ", "
				r = r + idx.toString() + ": " + this[idx].printString()
			}
			return r + "}"
		}
		Number.prototype.printString = justToString
		String.prototype.printString = function() {
			var r = "\""
			for (var idx in this)
				switch (this[idx]) {
					case "\r":	r += "\\r"; break;
					case "\n":	r += "\\n"; break;
					case "\t":	r += "\\t"; break;
					case "\"":	r += "\\\""; break;
					case "\\":	r += "\\\\"; break;
					default:		r += this[idx]
				}
			return r + "\""
		}
		Function.prototype.printString = justToString
		Array.prototype.printString = function() { return this.genericPrint("printString") }

		Array.__with__ = function(x) {
			var r = new Array()
			r[0] = x
			return r
		}

		Function.prototype.__hasInstance__ = function(x) {
			while (x !!= null && x !!= undefined) {
				if (x.__proto__ == this.prototype)
					return true
				// kludge required for Number and String
				if (x.__proto__ == x)
					return this == Object
				x = x.__proto__
			}
			// the standard states that null is not an instance of anything
			return false
		}

		Object.prototype.perform = function(m, args) {
			return this[m].apply(this, args)
		}

		Object.prototype["+"] = function(that) {
			return this.toString() + that.toString()
		}

		Array.prototype.map = function(f) {
			var r = []
			for (var idx in this)
				r[idx] = f(this[idx])
			return r
		}
		Array.prototype.reduce = function(f, z) {
			var r = z
			for (var idx in this)
				r = f(r, this[idx])
			return r
		}
		Array.prototype.push = function(x) {
			this[this.length] = x
		}
		Array.prototype.pop = function() {
			var ans = this[this.length - 1]
			this.length = this.length - 1
			return ans
		}
		String.prototype.charAt = function(idx) {
			return this[idx]
		}
		Math.min = function() {
			var ans = Infinity
			for (var idx in arguments)
				if (arguments[idx] < ans)
					ans = arguments[idx]
			return ans
		}
		Math.max = function() {
			var ans = -Infinity
			for (var idx in arguments)
				if (arguments[idx] > ans)
					ans = arguments[idx]
			return ans
		}
		Math.randomInt = function(n) {
			return Math.round(Math.random() * (n - 1))
		}
	'.! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 22:03'!
nullProto

	^ NullProto! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 06:47'!
numberProto

	^ NumberProto! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 06:41'!
objectProto

	^ ObjectProto! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 06:47'!
parser

	^ JSParser! !

!JSObject class methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 06:47'!
stringProto

	^ StringProto! !


JSObject subclass: #JSArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSArray methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 23:34'!
jsAt: key

	key isInteger ifTrue: [
		^ [super jsAt: key] on: Error do: [
			(key >= 0 and: [key < (self at: #length)])
				ifTrue: [Undefined]
				ifFalse: [self errorKeyNotFound]
		]
	].
	^ super jsAt: key! !

!JSArray methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 23:43'!
jsAt: key put: val

	key == #length ifTrue: [
		 | oldLength |
		(val isInteger not or: [val < 0]) ifTrue: [^ self error: 'invalid array length'].
		oldLength := self jsAt: #length.
		val to: oldLength - 1 do: [:idx | self at: idx put: Undefined].
		^ self at: #length put: val
	].
	key isInteger ifTrue: [
		 | oldLength |
		oldLength := self jsAt: #length.
		key + 1 > oldLength ifTrue: [self at: #length put: key + 1].
		^ self at: key put: val
	].
	^ super jsAt: key put: val! !

!JSArray methodsFor: 'as yet unclassified' stamp: 'aw 9/16/2007 12:39'!
jsKeys

	^ (0 to: (self jsAt: #length) - 1) asArray! !


JSObject subclass: #JSBuiltInProto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSBuiltInProto methodsFor: 'as yet unclassified' stamp: 'aw 9/10/2007 21:45'!
jsAt: key

	^ self at: key ifAbsent: [
		ObjectProto jsAt: key
	]! !


JSObject subclass: #JSContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSContext methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 14:18'!
jsAt: key put: val

	^ (self includesKey: key)
		ifTrue: [
			self at: key put: val
		] ifFalse: [
			(self at: #'__proto__') jsAt: key put: val
		]! !


JSObject subclass: #JSGlobalProto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSGlobalProto methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 17:33'!
init: n

	super init: n.
	self at: #'__proto__' put: nil.! !

!JSGlobalProto methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 17:23'!
jsAt: key

	^ self at: key ifAbsent: [
		| proto |
		proto := self at: #'__proto__'.
		proto
			ifNil: [Undefined]
			ifNotNil: [proto jsAt: key]
	]! !

!JSGlobalProto methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:55'!
jsAt: key put: val

	^ self at: key put: val! !

!JSGlobalProto methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:35'!
makeChild

	^ JSContext new
		at: #'__proto__' put: self;
		yourself! !


JSObject subclass: #JSObjectProto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSObjectProto methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 13:34'!
jsAt: key

	^ self at: key! !

!JSObjectProto methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 22:28'!
makeChild

	^ JSObject new
		at: #'__proto__' put: self;
		yourself! !


OMeta subclass: #JSParser
	instanceVariableNames: ''
	classVariableNames: 'CharEscapes Keywords'
	poolDictionaries: ''
	category: 'Javascript'!

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/27/2007 14:15'!
addExpr ::=

	<addExpr>:x	( <tok #'+'>	<mulExpr>:y	=> [{#send. #'+'. x. y}]
				| <tok #'-'>	<mulExpr>:y	=> [{#send. #'-'. x. y}]
				)
|	<mulExpr>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:09'!
alnum ::=

	<letter> | <digit>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/16/2007 12:31'!
andExpr ::=

	<andExpr>:x	<tok #'&&'>	<eqExpr>:y	=> [{#send. #'&&'. x. {#func. #(). {#return. y}}}]
|	<eqExpr>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:34'!
argList ::=

	<expr>:first (<tok #','> <expr>)*:rest	=> [rest addFirst: first; yourself]
|	<empty>								=> [#()]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:55'!
assign ::=

	"="
|	"+="
|	"++"
|	"-="
|	"--"
|	"*="
|	"/="
|	"%="
|	"&&="
|	"||="! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/28/2007 11:29'!
binding ::=

	<tok #name>:n <tok #'='> <expr>:v	=> [{#decl. n. v}]
|	<tok #name>:n					=> [{#decl. n}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 17:40'!
block ::=

	<tok #'{'> <srcElem>*:xs <tok #'}'>	=> [xs addFirst: #begin; yourself]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 13:39'!
case ::=

	<tok #case> <expr>:e <tok #':'> <srcElem>*:xs	=> [{#case. e. xs addFirst: #begin; yourself}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/31/2007 21:43'!
compiler

	^ JSCompiler! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/31/2007 21:43'!
declVisitor

	^ JSDeclVisitor! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 13:39'!
default ::=

	<tok #default> <tok #':'> <srcElem>*:xs	=> [{#default. xs addFirst: #begin; yourself}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 14:22'!
eqExpr ::=

	<eqExpr>:x	( <tok #'=='>	<relExpr>:y	=> [{#send. #'=='. x. y}]
				| <tok #'!!='>	<relExpr>:y	=> [{#send. #'!!='. x. y}]
				| <tok #'==='>	<relExpr>:y	=> [{#send. #'==='. x. y}]
				| <tok #'!!=='>	<relExpr>:y	=> [{#send. #'!!=='. x. y}]
				)
|	<relExpr>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:14'!
escapeChar ::=

	$\ <char>:c	=> [CharEscapes at: c]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 22:18'!
evalSrcElem :global ::=

	<srcElem>:tree
		!![(self declVisitor on: {tree} readStream) apply: #decls]:tree
		!![(self compiler on: {tree} readStream) apply: #compile]:tree
		!![(OParseTreeFlattener on: {tree} readStream) apply: #flatten]:tree
		=> [JSEvaluator new evaluate: tree withGlobal: global]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/29/2007 22:19'!
evalSrcElems :global ::=

	<evalSrcElem global>:x (<evalSrcElem global>:y !![y]:x)*	( <spaces> <end>	=> [x]
															| <empty>		=> [self error: 'end-of-input expected']
															)
|	<empty>																	=> [self error: 'source element expected']! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/22/2007 12:18'!
exponent ::=

	($e | $E) <integer>:i	=> ['e', i]
|	<empty>				=> ['e0']! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 11:25'!
expr ::=

	<orExpr>:e	( <tok #'?'> <expr>:t <tok #':'> <expr>:f	=> [{#if. e. t. f}]
				| <tok #'='> <expr>:rhs					=> [{#set. e. rhs}]
				| <tok #'+='> <expr>:rhs				=> [{#set. e. {#send. #'+'. e. rhs}}]
				| <tok #'-='> <expr>:rhs				=> [{#set. e. {#send. #'-'. e. rhs}}]
				| <tok #'*='> <expr>:rhs				=> [{#set. e. {#send. #'*'. e. rhs}}]
				| <tok #'/='> <expr>:rhs				=> [{#set. e. {#send. #'/'. e. rhs}}]
				| <tok #'%='> <expr>:rhs				=> [{#set. e. {#send. #'%'. e. rhs}}]
				| <tok #'&&='> <expr>:rhs				=> [{#set. e. {#send. #'&&'. e. rhs}}]
				| <tok #'||='> <expr>:rhs				=> [{#set. e. {#send. #'||'. e. rhs}}]
				| <empty>							=> [e]
				)! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 14:30'!
forLoop ::=

	<tok #for>	<tok #'('>	( <tok #var> <tok #name>:x <tok #'='> <expr>:e	=> [{#decl. x. e}]
							| <expr>
							| <empty>									=> [{#quote. nil}] ):i
				<tok #';'>	(<expr> | <empty> => [{#quote. true}]):c
				<tok #';'>	(<expr> | <empty> => [{#quote. nil}]):u
				<tok #')'>
		<stmt>:s															=> [{#for. i. c. u. s}]


|	<tok #for>	<tok #'('>	<tok #var> <tok #name>:x
				<tok #in>	<expr>:e
				<tok #')'>
		 <stmt>:s															=> [{#begin. {#decl. x}. {#forIn. {#func. #(#'__lv__'). {#set. {#get. #ctxt. {#quote. x}}. {#get. #ctxt. {#quote. #'__lv__'}}}}. e. s}}]


|	<tok #for>	<tok #'('>	<expr>:v
				<tok #in>	<expr>:e
				<tok #')'>
		 <stmt>:s															=> [{#forIn. {#func. #(#'__lv__'). {#set. v. {#get. #ctxt. {#quote. #'__lv__'}}}}. e. s}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:34'!
formals ::=

	<tok #name>:first (<tok #','> <tok #name>)*:rest	=> [rest addFirst: first; yourself]
|	<empty>											=> [#()]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:39'!
fractional ::=

	$. <natural>:n	=> ['.', n]
|	<empty>			=> ['']! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/11/2007 16:12'!
funcRest ::=

	!![self input]:ipos <tok #'('> <formals>:args <tok #')'> <tok #'{'> <srcElem>*:body <tok #'}'> !![self input]:fpos	=> [{#source. {#func. args. body addFirst: #begin; yourself}. 'function', (ipos sourceUntil: fpos)}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:39'!
integer ::=

	$- 				<natural>:n	=> ['-', n]
|	($+ | <empty>)	<natural>:n	=> [n]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/7/2007 13:44'!
json ::=

	<tok #'{'> <jsonBindings>:ps <tok #'}'>	=> [{#new. {#func. #(). ps}}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/7/2007 14:01'!
jsonBinding ::=

	<jsonPropertyName>:x <tok #':'> <expr>:v	=> [{#set. {#get. {#get. #ctxt. {#quote. #this}}. x}. v}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/7/2007 13:52'!
jsonBindings ::=

	<jsonBinding>:p (<tok #','> <jsonBinding>)*:ps	=> [{#begin. p}, ps]
|	<empty>										=> [{#quote. nil}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/7/2007 13:32'!
jsonPropertyName ::=

	(<tok #name> | <tok #number> | <tok #string>):p	=> [{#quote. p}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:11'!
keywords

	^ Keywords! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/27/2007 14:19'!
mulExpr ::=

	<mulExpr>:x	( <tok #'*'>	<unary>:y	=> [{#send. #'*'. x. y}]
				| <tok #'/'>	<unary>:y	=> [{#send. #'/'. x. y}]
				| <tok #'%'>	<unary>:y	=> [{#send. #'%'. x. y}]
				)
|	<unary>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:12'!
name ::=

	(<letter> | $_):first (<alnum> | $_)*:rest !![(first asString, (String withAll: rest)) asSymbol]:n	=> [(self keywords includes: n)
																								ifTrue: [{n. n}]
																								ifFalse: [{#name. n}]]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:26'!
natural ::=

	<digit>+:ds	=> [String newFrom: ds]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:39'!
newline ::=

	<exactly (Character cr)>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:39'!
noNewline ::=

	<spacesNoNewline> ~<newline>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/22/2007 12:19'!
number ::=

	<natural>:i <fractional>:f <exponent>:e	=> [{#number. (i, f, e) asNumber}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/16/2007 12:31'!
orExpr ::=

	<orExpr>:x	<tok #'||'>	<andExpr>:y	=> [{#send. #'||'. x. {#func. #(). {#return. y}}}]
|	<andExpr>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 18:55'!
postfix ::=

	<primExpr>:p	( <spacesNoNewline> <tok #'++'>	=> [{#post. #'+'. p}]
				| <spacesNoNewline> <tok #'--'>	=> [{#post. #'-'. p}]
				| <empty>						=> [p]
				)! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/27/2007 14:21'!
primExpr ::=

	<primExpr>:p
		( <tok #'['> <expr>:i <tok #']'>									=> [{#get. p. i}]
		| <tok #'.'> <tok #name>:m <tok #'('> <argList>:args <tok #')'>	=> [{#send. m. p}, args]
		| <tok #'.'> <tok #name>:f										=> [{#get. p. {#quote. f}}]
		| <tok #'('> <argList>:args <tok #')'>							=> [{#call. p}, args]
		)
|	<primExprHd>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/7/2007 13:27'!
primExprHd ::=

	<tok #'('> <expr>:e <tok #')'>								=> [e]
|	<tok #name>:n											=> [{#get. #ctxt. {#quote. n}}]
|	<tok #number>:n											=> [{#quote. n}]
|	<tok #string>:s											=> [{#quote. s}]
|	<tok #function> <funcRest>
|	<tok #new> <tok #name>:n <tok #'('> <argList>:a <tok #')'>	=> [{#new. {#get. #ctxt. {#quote. n}}}, a]
|	<tok #'['> <tok #']'>										=> [{#new. {#get. #ctxt. {#quote. #Array}}}]
|	<tok #'['> <expr>:x <tok #']'>								=> [{#send. #'__with__'. {#get. #ctxt. {#quote. #Array}}. x}]
|	<tok #'['> <expr>:first (<tok #','> <expr>)+:rest <tok #']'>		=> [{#new. {#get. #ctxt. {#quote. #Array}}. first}, rest]
|	<json>
! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/12/2007 17:00'!
relExpr ::=

	<relExpr>:x	( <tok #'>'>			<addExpr>:y	=> [{#send. #'>'. x. y}]
				| <tok #'>='>			<addExpr>:y	=> [{#send. #'>='. x. y}]
				| <tok #'<'>			<addExpr>:y	=> [{#send. #'<'. x. y}]
				| <tok #'<='>			<addExpr>:y	=> [{#send. #'<='. x. y}]
				| <tok #instanceof>	<addExpr>:y	=> [{#send. #'__hasInstance__'. y. x}]
				)
|	<addExpr>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/22/2007 12:07'!
sc ::=

	<spacesNoNewline> (<newline> | &"}" | <end>)
|	<tok #';'>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:39'!
space ::=

	"//" (~<newline> <char>)*
|	"/*" (~"*/" <char>)* "*/"
|	<super #space>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:39'!
spacesNoNewline ::=

	(~<newline> <space>)*! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:58'!
special ::=

	(<special1> | <special2> | <special3> | <special4>):s	=> [{s asSymbol. s asSymbol}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 12:59'!
special1 ::=

	"("
|	")"
|	"{"
|	"}"
|	"["
|	"]"
|	","
|	";"
|	"?"! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:00'!
special2 ::=

	":"
|	"!!=="
|	"!!="
|	"==="
|	"=="
|	"="
|	">="
|	">"
|	"<=" ! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:01'!
special3 ::=

	"<"
|	"++"
|	"+="
|	"+"
|	"--"
|	"-="
|	"-"
|	"*="! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:02'!
special4 ::=

	"*"
|	"/="
|	"/"
|	"%="
|	"%"
|	"&&="
|	"&&"
|	"||="
|	"||"
|	"."
|	"!!"! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/11/2007 16:10'!
srcElem ::=

	<tok #function> !![self input]:ipos <tok #name>:n <funcRest>:f !![self input]:fpos	=> [{#decl. n. {#source. f. 'function', (ipos sourceUntil: fpos)}}]
|	<stmt>! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 18:53'!
stmt ::=

	<tok #'{'> <srcElem>*:s <tok #'}'>								=> [s addFirst: #begin; yourself]
|	<tok #var> <binding>:first (<tok #','> <binding>)*:rest <sc>		=> [{#begin. first}, rest]
|	<tok #if> <tok #'('> <expr>:c <tok #')'>
		<stmt>:t
		( <tok #else> <stmt>:f										=> [{#if. c. t. f}]
		| <empty>												=> [{#if. c. t}]
		)
|	<tok #while> <tok #'('> <expr>:c <tok #')'> <stmt>:s				=> [{#while. c. s}]
|	<tok #do> <stmt>:s <tok #while> <tok #'('> <expr>:c <tok #')'> <sc>	=> [{#doWhile. s. c}]
|	<forLoop>
|	<tok #switch> <tok #'('> <expr>:e <tok #')'> <tok #'{'> <case>*:cs1
		(<default>:d => [{d}] | <empty> => [{}]):optDef
		<case>*:cs2 <tok #'}'>										=> [{#switch. e}, cs1, optDef, cs2]
|	<tok #break> <sc>												=> [#(break)]
|	<tok #continue> <sc>											=> [#(continue)]
|	<tok #throw> <spacesNoNewline> <expr>:x <sc>					=> [{#throw. x}]
|	<tryCatchFinally>
|	<tok #return> <spacesNoNewline> <expr>:e <sc>					=> [{#return. e}]
|	<tok #return> <sc>											=> [{#return}]
|	<tok #';'>													=> [{#quote. nil}]
|	<expr>:e <sc>													=> [e]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:31'!
str ::=

	$' (<escapeChar> | ~$' <char>)*:cs $'	=> [{#string. String newFrom: cs}]
|	$" (<escapeChar> | ~$" <char>)*:cs $"	=> [{#string. String newFrom: cs}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:06'!
tok :tt ::=

	<token>:t ?[t first == tt]	=> [t second]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:23'!
token ::=

	<spaces> (<name> | <number> | <str> | <special>)! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 8/21/2007 13:24'!
tokens ::=

	<token>*! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 14:20'!
tryCatchFinally ::=

	<tok #try> <block>:t
		( <tok #catch> <tok #'('>	<tok #name>:e <tok #')'>	<block>:c			( <tok #finally> <block>
																			| <empty> => [{#quote. 'nil'}] ):f
		|						!!['''__e__''']:e			!![{#quote. nil}]:c	<tok #finally> <block>:f
		)																									=> [{#try. t. e. c. f}]! !

!JSParser methodsFor: 'as yet unclassified' stamp: 'aw 9/6/2007 18:27'!
unary ::=

	<tok #'-'>	<postfix>:p	=> [{#send. #'-'. {#quote. 0}. p}]
|	<tok #'+'>	<postfix>:p	=> [p]
|	<tok #'++'>	<postfix>:p	=> [{#set. p. {#send. #'+'. p. {#quote. 1}}}]
|	<tok #'--'>	<postfix>:p	=> [{#set. p. {#send. #'-'. p. {#quote. 1}}}]
|	<tok #'!!'>	<postfix>:p	=> [{#send. #'!!'. p}]
|				<postfix>! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

JSParser class
	instanceVariableNames: ''!

!JSParser class methodsFor: 'as yet unclassified' stamp: 'aw 9/13/2007 13:10'!
initialize
"
	JSParser initialize
"

	Keywords := IdentitySet newFrom: #(break case catch continue default do else for finally function if in instanceof new return switch throw try var while).
	CharEscapes := IdentityDictionary new.
	0 to: 255 do: [:a |
		| c |
		c := a asCharacter.
		CharEscapes at: c put: c.
	].
	CharEscapes at: $\ put: $\.
	CharEscapes at: $n put: Character lf.
	CharEscapes at: $r put: Character cr.
	CharEscapes at: $t put: Character tab.
	CharEscapes at: $" put: $".
	CharEscapes at: $' put: $'.
! !


Notification subclass: #JSThrow
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript'!

!JSThrow methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 17:03'!
value

	^ value! !

!JSThrow methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 17:04'!
value: x

	value := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

JSThrow class
	instanceVariableNames: ''!

!JSThrow class methodsFor: 'as yet unclassified' stamp: 'aw 9/5/2007 17:04'!
withValue: x

	^ self new value: x; yourself! !

JSObject initialize!
JSParser initialize!
